<?php // $Id: news.form.inc,v 1.8 2010/07/30 18:49:37 vauxia Exp $

/**
 * @file
 *
 * Form functions for the News module.
 */

/**
 * The form page for user-initiated Newsletter activities.
 */
function news_form($form_state, $nids = array()) {
  if (!$send = $form_state['send_profile']) {
    $send = (object) send_profile_load('news');
    $send->nids = ($nids && !is_array($nids)) ? explode(' ', $nids) : $nids;
    $send->message_element = $nids ? 'send_message_compose': 'send_message_edit';
    $send->compose_advanced = TRUE;
    $send->action = request_uri();
  }

  if (isset($form_state['clicked_button'])) {
    if ($form_state['clicked_button']['#value'] == t('Edit')) {
      $form_state['send_profile']->message_element = 'send_message_edit';
    }
    elseif ($form_state['clicked_button']['#value'] == t('Compose')) {
      $form_state['send_profile']->message_element = 'send_message_compose';
      $form_state['send_profile']->compose_advanced = TRUE;
    }
  }

  // Ensure that the *original* form action is used, not an AHAH-rewritten one.
  $form['#action'] = request_uri();

  $form['send'] = array(
    '#type' => 'send',
    '#send_profile' => $send,
  );

  $form['extra']['compose'] = array(
    '#type' => 'submit',
    '#value' => t('Compose'),
    '#submit' => array('send_submit_refresh'),
  );

  $form['extra']['edit'] = array(
    '#type' => 'submit',
    '#value' => t('Edit'),
    '#submit' => array('send_submit_refresh'),
  );

  $form['buttons']['test'] = array(
    '#type' => 'submit',
    '#value' => t('Send test message'),
    '#submit' => array('news_form_test_delivery'),
  );
  $form['buttons']['submit'] = array(
    '#type' => 'submit', '#value' => t('Send'),
  );

  return $form;
}

/**
 * A #process handler for the news_mlm form element.
 */
function news_mlm_element_process($element, $edit, &$form_state, $form) {
  $profile =& $form_state['send_profile'];

  $name = $element['#name'];
  /*
  if (isset($form_state['send_profile']->{$name}['lists'])) {
    $selected = $form_state['send_profile']->{$name}['lists'];
  }
  elseif (isset($element['#value']['lists'])) {
    $selected = $element['#value']['lists'];
  }
  else {
    $selected = array();
  }
  if ($edit) print_r($edit);
  $selected = $edit ? $edit['lists'] : $form_state['send_profile']->recipients();
  */
  $element['lists'] = array(
    '#parents'       => array('send', 'lists'),
    '#type'          => 'checkboxes',
    '#title'         => t('Mailing lists'),
    '#options'       => $profile->availableLists(),
    '#default_value' => $profile->lists(),
    '#required'      => $element['#required'],
  );
  return $element;
}

/**
 * An implementation of form_type_hook_value for news_mlm elements.
 */
function form_type_news_mlm_value(&$element, $edit = array()) {
  $lists = array();
  if ($element['#value']) {
    foreach ($element['#value']['lists'] as $lid => $status) {
      if ($status) $lists[] = array('lid' => $lid);
    }
  }
  return $lists;
}

/**
 * A #process handler for the news_contact form element.
 */
function news_contact_element_process($element, $edit, &$form_state, $form) {
  $element['name'] = array(
    '#type'          => 'textfield',
    '#title'         => t('Name'),
    '#default_value' => variable_get('site_name', 'Drupal'),
  );
  $element['mail'] = array(
    '#type'          => 'textfield',
    '#title'         => t('E-mail'),
    '#default_value' => variable_get('site_mail', ''),
  );
  return $element;
}

/**
 * A submit handler for the news form that delivers a test message to the admin.
 */
function news_form_test_delivery($form, &$form_state) {
  global $user;
  $profile =& $form_state['send_profile'];
  $message = $profile->message();

  mimemail($profile->sender(), $user, $message['subject'], $message['body']);
  drupal_set_message(t('Test message sent to !mail', array('!mail' => $user->mail)));
}
