<?php // $Id: news.views_default.inc,v 1.1 2009/03/19 19:03:13 vauxia Exp $

/**
 * Implementation of hook_views_default_views().
 */
function news_views_default_views() {
  $view = new view;
  $view->name = 'news';
  $view->description = 'Tracking for items sent from the News module';
  $view->tag = 'news, send';
  $view->view_php = '';
  $view->base_table = 'send';
  $view->is_cacheable = FALSE;
  $view->api_version = 2;
  $view->disabled = FALSE; /* Edit this to true to make a default view disabled initially */
  $handler = $view->new_display('default', 'Defaults', 'default');
  $handler->override_option('fields', array(
    'timestamp' => array(
      'label' => 'Timestamp',
      'date_format' => 'small',
      'custom_date_format' => '',
      'exclude' => 0,
      'id' => 'timestamp',
      'table' => 'send',
      'field' => 'timestamp',
      'override' => array(
        'button' => 'Override',
      ),
      'relationship' => 'none',
    ),
    'subject' => array(
      'label' => 'Subject',
      'exclude' => 0,
      'id' => 'subject',
      'table' => 'send',
      'field' => 'subject',
      'override' => array(
        'button' => 'Override',
      ),
      'relationship' => 'none',
    ),
  ));
  $handler->override_option('sorts', array(
    'timestamp' => array(
      'order' => 'DESC',
      'granularity' => 'second',
      'group_by_node' => 0,
      'id' => 'timestamp',
      'table' => 'send',
      'field' => 'timestamp',
      'relationship' => 'none',
    ),
  ));
  $handler->override_option('filters', array(
    'profile' => array(
      'operator' => 'in',
      'value' => array(
        'news' => 'news',
      ),
      'group' => '0',
      'exposed' => FALSE,
      'expose' => array(
        'operator' => FALSE,
        'label' => '',
      ),
      'id' => 'profile',
      'table' => 'send',
      'field' => 'profile',
      'relationship' => 'none',
    ),
  ));
  $handler->override_option('access', array(
    'type' => 'none',
  ));
  $handler->override_option('title', 'Newsletter tracking');
  $handler->override_option('style_plugin', 'table');
  $handler = $view->new_display('page', 'Page', 'page_1');
  $handler->override_option('path', 'send/news/track');
  $handler->override_option('menu', array(
    'type' => 'tab',
    'title' => 'Track',
    'weight' => '0',
    'name' => 'navigation',
  ));
  $handler->override_option('tab_options', array(
    'type' => 'none',
    'title' => '',
    'weight' => 0,
  ));
  $views[$view->name] = $view;

  return $views;
}
